﻿'
' Copyright (c) 2016, MindFusion LLC - Bulgaria.
'


Class MainWindow

	Sub New()

		InitializeComponent()

		diagram.DefaultShape = Shapes.Rectangle
		diagram.Bounds = New Rect(0, 0, 3840, 3840)

		radioButton1.IsChecked = True

		diagram.NodeEffects.Add(New GlassEffect())
		diagram.NodeEffects.Add(New AeroEffect())

		Dim shapeNodeStyle As New Style()
		shapeNodeStyle.Setters.Add(New Setter(ShapeNode.BrushProperty, _
		 New LinearGradientBrush(Colors.LightGray, Colors.DarkTurquoise, 80)))
		shapeNodeStyle.Setters.Add(New Setter(ShapeNode.FontSizeProperty, 10.75))
		diagram.ShapeNodeStyle = shapeNodeStyle

		Dim pb1 As ShapeNode, pb2 As ShapeNode, pb3 As ShapeNode, pb4 As ShapeNode, decb1 As ShapeNode, decb2 As ShapeNode

		apat1 = New AnchorPattern(New AnchorPoint() _
		 { _
		  New AnchorPoint(50, 0, True, True), _
		  New AnchorPoint(100, 50, True, True), _
		  New AnchorPoint(50, 100, True, True), _
		  New AnchorPoint(0, 50, True, True) _
		  })

		apat2 = New AnchorPattern(New AnchorPoint() _
		  { _
		  New AnchorPoint(10, 0, True, False, MarkStyle.Circle, Brushes.RoyalBlue), _
		  New AnchorPoint(50, 0, True, False, MarkStyle.Circle, Brushes.Blue), _
		  New AnchorPoint(90, 0, True, False, MarkStyle.Circle, Brushes.Firebrick), _
		  New AnchorPoint(10, 100, False, True, MarkStyle.Rectangle), _
		  New AnchorPoint(50, 100, False, True, MarkStyle.Rectangle), _
		  New AnchorPoint(90, 100, False, True, MarkStyle.Rectangle), _
		  New AnchorPoint(0, 50, True, True, MarkStyle.[Custom]) _
		  })

		pb1 = New ShapeNode(diagram)
		pb1.Bounds = New Rect(38.4, 26.88, 96, 69.12)
		pb1.Shape = Shapes.Ellipse
		pb1.Text = "Start"
		pb1.AnchorPattern = apat1
		diagram.Nodes.Add(pb1)

		pb2 = New ShapeNode(diagram)
		pb2.Bounds = New Rect(76.8, 288, 96, 69.12)
		pb2.Text = "node 1"
		pb2.AnchorPattern = apat2
		diagram.Nodes.Add(pb2)

		pb3 = New ShapeNode(diagram)
		pb3.Bounds = New Rect(268.8, 268.8, 96, 69.12)
		pb3.Text = "node 2"
		pb3.AnchorPattern = apat2
		diagram.Nodes.Add(pb3)

		pb4 = New ShapeNode(diagram)
		pb4.Bounds = New Rect(307.2, 384, 96, 69.12)
		pb4.Shape = Shapes.Ellipse
		pb4.Text = "End"
		pb4.AnchorPattern = apat1
		diagram.Nodes.Add(pb4)

		decb1 = New ShapeNode(diagram)
		decb1.Bounds = New Rect(76.8, 134.4, 115.2, 76.8)
		decb1.Shape = Shapes.Decision
		decb1.Text = "check 1"
		decb1.AnchorPattern = AnchorPattern.Decision1In3Out
		diagram.Nodes.Add(decb1)

		decb2 = New ShapeNode(diagram)
		decb2.Bounds = New Rect(268.8, 115.2, 115.2, 76.8)
		decb2.Shape = Shapes.Decision
		decb2.Text = "check 2"
		decb2.AnchorPattern = AnchorPattern.Decision2In2Out
		diagram.Nodes.Add(decb2)

		Dim link As New DiagramLink(diagram, decb1, decb2)
		diagram.Links.Add(link)

		Dim router = TryCast(diagram.LinkRouter, QuickRouter)
		If router IsNot Nothing Then
			router.UBendMaxLen = 10
		End If
		diagram.RoutingOptions.TriggerRerouting = diagram.RoutingOptions.TriggerRerouting Or RerouteLinks.WhileCreating
		diagram.RoutingOptions.Anchoring = Anchoring.Keep

	End Sub

	Private Sub radioButton1_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
		diagram.DefaultShape = Shapes.Rectangle
	End Sub

	Private Sub radioButton2_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
		diagram.DefaultShape = Shapes.Decision
	End Sub

	Private Sub diagram_NodeCreated(ByVal sender As Object, ByVal e As NodeEventArgs)
		Dim node As ShapeNode = TryCast(e.Node, ShapeNode)
		If node Is Nothing Then
			Return
		End If

		If node.Shape Is Shapes.Decision Then
			node.AnchorPattern = AnchorPattern.Decision1In3Out
		Else
			node.AnchorPattern = apat2
		End If
	End Sub

	Private Sub OnLoadClick(ByVal sender As Object, ByVal e As RoutedEventArgs)
		Dim openDlg As New Microsoft.Win32.OpenFileDialog()
		If openDlg.ShowDialog() = True Then
			diagram.LoadFromXml(openDlg.FileName)
		End If
	End Sub

	Private Sub OnSaveClick(ByVal sender As Object, ByVal e As RoutedEventArgs)
		Dim saveDlg As New Microsoft.Win32.SaveFileDialog()
		If saveDlg.ShowDialog() = True Then
			diagram.SaveToXml(saveDlg.FileName)
		End If

	End Sub


	Private apat1 As AnchorPattern
	Private apat2 As AnchorPattern

End Class
